# LiquityAdjust

### Description

Adjusts a Trove by depositing or withdrawing collateral and borrowing or repaying debt.

### Action ID

`0xe4562a9c`

### SDK Action

```ts
const liquityAdjustAction = new dfs.actions.liquity.LiquityAdjustAction(
    maxFeePercentage,
    collAmount,
    lusdAmount,
    collChange,
    debtChange,
    from,
    to,
    upperHint,
    lowerHint
);
```

### Action Type

`STANDARD_ACTION`

### Input Parameters

```solidity
    /// @param maxFeePercentage Highest borrowing fee to accept, ranges between 0.5 and 5%
    /// @param collAmount Amount of ETH to supply/withdraw
    /// @param lusdAmount Amount of LUSD tokens to borrow/payback
    /// @param collChange Whether to supply or withdraw collateral
    /// @param debtChange Whether to borrow or payback debt
    /// @param from Address where to pull the tokens from
    /// @param to Address that will receive the tokens
    /// @param upperHint Upper hint for finding a Trove in linked list
    /// @param lowerHint Lower hint for finding a Trove in linked list
    struct Params {
        uint256 maxFeePercentage;
        uint256 collAmount;
        uint256 lusdAmount;
        CollChange collChange;
        DebtChange debtChange;
        address from;
        address to;
        address upperHint;
        address lowerHint;
    }
```

### Return Value

```solidity
return bytes32(borrowedAmount);
```

### Events and Logs

```solidity
emit ActionEvent("LiquityAdjust", logData);
logger.logActionDirectEvent("LiquityAdjust", logData);
bytes memory logData = abi.encode(params);
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.defisaver.com/actions/liquity/liquityadjust.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
